type int = Int.t

signature DOCUMENT_STRUCTS =
   sig
      structure Color: COLOR
   end

signature DOCUMENT =
   sig
      include DOCUMENT_STRUCTS
	 
      datatype tag = B | EM | I | PL | S | TT | U
                   | Size of int | Color of Color.t

      val tagToStartEndStrings: tag -> string * string
      val startTagToString: tag -> string
      val endTagToString: tag -> string
      val tagToStartSize: tag -> int

      datatype t = Doc of item list
      and item = Text of string
	       | Tagged of tag * t

      val size : t -> int
      val toString: t -> string
      val output : t * Out.t -> unit
   end

