functor Doit (S: DOIT_STRUCTS): DOIT = 
struct

open S

structure Eval = Eval (structure Document = Document
		       structure Meaning = Meaning)
structure Parse = Parse (structure Document = Document)
structure Peephole = Peephole(structure Document = Document
			      structure Meaning = Meaning)
structure Optimize = Optimize (structure Document = Document
			       structure Meaning = Meaning
			       structure Peephole = Peephole)

fun doit (limit: Time.t, ins, out): unit =
   let
      fun temp () = File.temp {prefix = "/tmp/file", suffix = "ng"}
      val (best, out') = temp ()
      val bestRef = ref best
      fun loop n =
	 if In.endOf ins
	    then n
	 else let
		 val s = In.input ins
		 val _ = Out.output (out', s)
	      in loop (n + String.size s)
	      end
      val n = loop 0
      val _ = Out.close out'
      val bestLength = ref n
      val document = Parse.parse best
      val meaning = Eval.eval document
      val t = Time.now ()
      fun new d =
	 if not (Meaning.equals (meaning, Eval.eval d))
	    then
	       if false
		  then
		     Out.output
		     (Out.error,
		      "optimizer returned document with wrong meaning\n")
	       else ()
	 else
	    let
	       val n = Document.size d
	    in
	       if n < !bestLength
		  then
		     let
			val (best, out) = temp ()
			val _ = Document.output (d, out)
			val _ = Out.close out
			val old = !bestRef
			val _ = bestRef := best
			val _ = File.remove old
		     in
			()
		     end
	       else ()
	    end
      val _ = 
	 Engine.timeLimit
	 ((* subtract off a little slop *)
	  Time.- (limit, Time.seconds (IntInf.fromInt 5)), fn () =>
	  Optimize.optimize (document, meaning, new))
      val _ =
	 File.withIn (!bestRef, fn ins => In.outputAll (ins, out))
      val _ = File.remove (!bestRef)
   in
      ()
   end

end
