functor Eval (S: EVAL_STRUCTS): EVAL = 
struct

open S

structure Color = Document.Color
structure Proprec = Meaning.Proprec

fun eval (d: Document.t) =
   let
      datatype z = datatype Document.tag
      val prev: Meaning.decchar ref  = ref {c = #" ",
					    p = Proprec.root}
      fun loop (Document.Doc items,
		context as {b, em , i, s, tt, u, size, color}: Proprec.t,
		ac: Meaning.internal list) =
	 List.fold
	 (items, ac, fn (item, ac) =>
	  case item of
	     Document.Text s =>
		String.fold
		(s, ac, fn (c, ac) =>
		 let
		    fun add (c, p) =
		       let
			  val z = {c = c, p = p}
			  val _ = prev := z
		       in
			  Meaning.toInternal z :: ac
		       end
		 in
		    if not (Char.isSpace c)
		       then add (c, context)
		    else
		       let
			  val curSpace =
			     {b = false,
			      color = if u = 0 then Color.White else color,
			      em = false,
			      i = false, 
			      s = false,
			      size = size,
			      tt = tt,
			      u = u}
		       in
			  if tt
			     then add (c, curSpace)
			  else
			     case ac of
				[] => add (#" ", curSpace)
			      | _ =>
				   let
				      val {c, p} = !prev
				   in
				      if c = #" "
					 andalso Proprec.equals (p, curSpace)
					 then ac
				      else add (#" ", curSpace)
				   end
		       end
		 end)
	   | Document.Tagged (tag, d) =>
		loop (d, Proprec.update (context, tag), ac))
      val internals = loop (d, Proprec.root, [])
   in
      Array.fromListRev internals
   end


end
