type int = Int.t

signature MEANING_STRUCTS =
   sig
      structure Color: COLOR
      structure Document: DOCUMENT
      sharing Color = Document.Color
   end

signature MEANING =
   sig
      include MEANING_STRUCTS
	 
      structure Proprec:
	 sig
	    type t = {b: bool,
			color: Color.t,
			em: bool,
			i: bool,
			s: bool,
			size: int option, (* NONE means size unknown *)
			tt: bool,
			u: int}

	    val equals: t * t -> bool
	    val root: t
	    val space: t -> t
	    val update: t * Document.tag -> t
	 end

      type decchar = { c: char, p: Proprec.t }
	 
      type internal

      type t = internal array

      val equals: t * t -> bool
      val explainNonEquals: t * t * Out.t -> unit
      val layoutDecchar : decchar -> Layout.t
      val layout: t -> Layout.t
      val toInternal : decchar -> internal
      val toExternal : internal -> decchar

      val testAll : unit -> unit
   end
