signature OPTIMIZE_STRUCTS = 
   sig
      structure Document: DOCUMENT
      structure Meaning: MEANING
      sharing Document = Meaning.Document
      structure Peephole: PEEPHOLE
      sharing Document = Peephole.Document
      sharing Meaning = Peephole.Meaning
   end

signature OPTIMIZE = 
   sig
      include OPTIMIZE_STRUCTS
      
      (* Optimize document with given meaning, calling function on each
       * optimized document.
       *)
      val optimize: Document.t * Meaning.t * (Document.t -> unit) -> unit
   end

functor TestOptimize (S: OPTIMIZE): sig end = 
struct

val _ = print "TestOptimize\n"

open S

val _ = Assert.assert ("Optimize", fn () => true)

end
